# Fichier prfrence.tcl<BR>
# contient la dfinition des prfrence et autres options de gred
#
# <A HREF="mailto:diam@ensta.fr>diam@ensta.fr</A> le 29/06/96<BR>

########################################################################
# gred:initPrefs --
# 
# 
# 
proc gred:initPrefs args {
global gred

    # initialisation des variables globales non accessibles par l'utilisateur
    
    set gred(cursor,withSelection) "iron_cross"
    
    set gred(etape,border) 2
    
    set gred(etape,options) {type name state action file comment}
    set gred(etape,type) {Normal Initial Hyper Macro MacroBegin MacroEnd}
    set gred(etape,name) {"Etape normale" "Etape initiale" "Hyper tape"\
                          "Macro tape" "Dbut de macro tape" \
                          "Fin de macro tape"}
    set gred(etape,state) {active inactive}
    
    set gred(transition,options) {name receptivity comment}
    
    set gred(grid) 25   ;# pixel pour l'instant, puis : 0.5cm
    
    # L'initialisation des preferences (Pref_Init) est reporte dans 
    # dans la procdure gred:start)

    Pref_Add {-group General
      -var gred(admin)   -xres admin -default 1
      -type BOOLEAN
      -comment "Privilge d'administrateur de gred"
      -help "Permet d'avoir un (ou des) menu supplmentaire pour la\
       gestion et la maintenance de cette application"
    }
    Pref_Add {-group General
      -var gred(untitled)
      -type STRING
      -default "Untitled\t\t"
      -comment "Titre par dfault"
    }
    Pref_Add {-group General
      -var gred(userMail)
      -type STRING
      -comment "Adresse e-mail de l'utilisateur"
      -default "diam@ensta.fr"
      -help "Prfrence ncessaire pour permettre de faire des \"bugs reports\"  l'quipe de developpement."
    }
    # Pref_Add {-group General
    #   -var gred(geometry)
    #   -xres geometry
    #   -default 10+10x400x700
    #   -type GEOMETRY
    #   -comment "Gometrie de l'application"
    # }
    
#     option add *draw.c.width 20c
#     option add *draw.c.height 10c
#     option add *draw.c.scrollRegion {0 0 21c 29.7c}
    option add *draw.c.width 20c
    option add *draw.c.height 10c
# La taille du canvas devrait tre A2 mais une imprimante ne pouvant pas 
# imprimer sur les bords d'une page il est plus judicieux de diminuer la taille
# canvas pour se mettre  l'abrit des problemes ! (bidouille...)
#     option add *draw.c.scrollRegion {0 0 42c 59.4c}
    option add *draw.c.scrollRegion {0 0 40c 57.4c}

    # Pref_Add {-group General
    #   -var gred(canvas,width)
    #   -default 850
    #   -comment "Largeur du canvas"
    # }
    # Pref_Add {-group General
    #   -var gred(canvas,height)
    #   -default 15c
    #   -comment "Hauteur du canvas"
    # }
    
    # Groupe "Grafcet" : aspect graphique gnral.
    # # set gred(fontSize) 8 ;
    # # Pref_Add {-group Grafcet
    # #   -var gred(fontSize)
    # #   -default 12
    # #   -type LENGTH
    # #   -comment "Taille du texte"
    # #   -help "BLA BLA BLA BLA :-)"
    # # }
    # # Pref_Add {-group Grafcet
    # #   -var gred(fontGrafcet)
    # #   -default {-*-courier-bold-r-normal-*-12-*-*-*-*-*-iso8859-*}
    # #   -type FONTE
    # #   -comment "Fonte du grafcet"
    # #   -help "Utilise pour les noms d'tape, de transition, d'action, ..."
    # # }
    Pref_Add {-group Grafcet
      -var gred(fontGrafcet)
      -default {courier 12 bold}
      -type FONTE
      -comment "Fonte du grafcet"
      -help "Utilise pour les noms d'tape, de transition, d'action, ..."
    }
    Pref_Add {-group Grafcet
      -var gred(sequence,yStep)
      -default 60
      -type LENGTH
      -comment "Pas entre tape/transition pour la cration de squence"
    }
    # 
    Pref_Add {-group Grafcet
      -var gred(grid,color)
      -default #88F
      -type COLOR
      -comment "Couleur de la grille"
    }
    #
    Pref_Add {-group Grafcet
      -var gred(defaultSourceObjectType)
      -default Etape
      -type ENUM
      -typeargs {Etape Trans}
      -comment "Type d'objet source  crer par dfaut"
      -help "Le type de l'objet cr lorsqu'on clique sur une zone vide\
             peut etre modifi temporairement par appui sur <Alt> (suivant\
             la plateforme) au moment du clique."
    }
    
    Pref_Add {-group Etape
      -var gred(etape,height) 
      -xres etapeWidth 
      -default 35
      -type LENGTH
      -comment "Largeur d'une tape"
    }
#     Pref_Add {-group Etape
#       -var gred(etape,border) 
#       -xres etapeBorder 
#       -default 2
#       -type LENGTH
#       -comment "Epaisseur du trait entourant l'tape"
#     }
    Pref_Add { -group Etape
      -type COLOR
      -var gred(look,etapeBackground) 
      -default white
      -comment "Couleur du fond d'tape"
    }
    Pref_Add { -group Etape
      -type STRING
      -var gred(etape,nameIndex) 
      -default X1
      -comment "Indexation du nom des tapes"
      -help "Les noms des tapes se dclineront suivants le nom spcifi.\nPar exemple, si vous entrer X1n, tous les noms seront X1n, X2n, X3n, etc..."
    }
    
    Pref_Add {-group Transition
      -var gred(transition,width) 
      -xres transitionWidth 
      -default 25
      -type LENGTH
      -comment "Largeur d'une transition"
    }
    Pref_Add {-group Transition
      -var gred(transition,showName) 
      -default 1
      -type BOOLEAN
      -comment "Afficher le nom de la transition ?"
      -help "Prfrence prmettant d'afficher ou non le nom d'une\
             transition.\nSi cette option est valide, le nom de la transition\
             s'affichera  gauche de celle-ci."
    }
    Pref_Add {-group Transition
      -var gred(transition,height) 
      -xres transitionHeight 
      -default 4
      -type LENGTH
      -comment "Hauteur d'une transition"
    } 
    Pref_Add {-group Transition
      -var gred(transition,link) 
      -xres transitionLink 
      -default 5
      -type LENGTH
      -comment "Longueur mini du lien cot d'une transition"
    } 
    Pref_Add {-group Transition
      -var gred(doubleLine,height) 
      -xres doubleLineHeight 
      -default 4
      -type LENGTH
      -comment "Distance entre les doubles lignes d'une transition"
    }
    Pref_Add { -group Transition
      -type STRING
      -var gred(transition,nameIndex) 
      -default T1
      -comment "Indexation du nom des transitions"
      -help "Les noms des transitions se dclineront suivants le nom spcifi.\nPar exemple, si vous entrer X1n, tous les noms seront X1n, X2n, X3n, etc..."
    }
    ####################################################################
    ## Groupe Link : gestion et apparence des liens
    ####################################################################
    Pref_Add {-group Link
      -var gred(link,width) 
      -xres linkWidth 
      -default 2
      -type LENGTH
      -comment "Epaisseur des liens"
      -help "Cette dimension est galement utilise pour l'paisseur\
             des doubles lignes."
    }
    Pref_Add {-group Link
      -var gred(link,handlesize) 
      -xres handleSize 
      -default 3
      -type LENGTH
      -comment "Taille des poignes d'dition des liens"
      -help "Cette dimension reprsente le demi cot des poignes\
             lors de l'dition des liens."
    }
    

    ####################################################################
    ####################################################################
    ####################################################################
    ###### A VIRER BIENTOT
    ####################################################################
    Pref_Add {-group Transition
      -var gred(doubleLine,offset) 
      -xres doubleLineOffset 
      -default 5
      -type LENGTH
      -comment "Longueur min du dplacement latrale d'une double ligne"
    } 
    ####################################################################
    ####################################################################
    ####################################################################
    ####################################################################
    
    Pref_Add {-group Transition
      -var gred(doubleLine,xOffset) 
      -xres doubleLineXOffset 
      -default 5
      -type LENGTH
      -comment "Longueur minimale du dplacement latral d'une double ligne"
    } 
    Pref_Add {-group Transition
      -var gred(doubleLine,yOffset) 
      -xres doubleLineYOffset 
      -default 10
      -type LENGTH
      -comment "Longueur minimale du segment de droite entre une\
                transiton et sa double ligne"
    } 

    
    Pref_Add {-group Look
      -var canvas(scrollside) -xres scrollbarSide -default right
      -type ENUM   -typearg {left right}
      -comment "Position de la scrollBar"
      -help "La barre de dfilement verticale d'un widget text ou d'un\
       canvas peut etre place  droit (right) ou  gauche (left)"
    } 
    
    Pref_Add { -group Look
      -type COLOR
      -var gred(look,transitionBackground) 
      -default black
      -comment "Couleur du fond de transition"
    }    
    
    Pref_Add { -group Look
      -type COLOR
      -var gred(look,canvasBackground) 
      -xres canvasBackground 
      -default white
      -comment "Couleur du fond de la fentre principale"
    }    
    
    Pref_Add { -group Canvas
      -type COLOR
      -var gred(virtualColor) 
      -xres virtualColor 
      -default red
      -comment "Couleur des objets virtuels"
      -helt "Les objets virtuels sont le rectangle de slection, les liaisons\
             en cours d'dition et les \"fantmes\" d'objet en cours de \
             dplacement."
    }    
    
    Pref_Add {-group Canvas
      -var canvas(overlappingDelta)
      -default 2
      -type LENGTH
      -comment "Distance de slection (overlapping)."
      -help "Distance en dessous de laquelle un objet est considr\
             comme tant \"sous la souris\""
    }
    Pref_Add {-group Canvas
      -var canvas(dragDelta)
      -default 10
      -type LENGTH
      -comment "Distance mini de dplacement souris."
      -help "Distance minimale ncessaire pour qu'un dplacement de souris\
             soit pris en compte"
    }
    Pref_Add {-group Selection
      -var gred(drag,limit)
      -default 5
      -type LENGTH
      -comment "Limite de dclenchement du mode Drag"
    }
    Pref_Add {-group Selection
      -var gred(sel,color)
      -default red
      -type COLOR
      -comment "Couleur de la slection"
    }
    Pref_Add {-group Selection -type ENUM
      -var gred(selectMode)
      -typearg {enclosed overlapping}
      -default enclosed
      -comment "Mode de capture de la slection"
      -help "Indique si le rectangle de slection doit entirement\
             (enclosed) ou partiellement (overlapping) entourer les objets\
             pour les slectionner."
    }
    
    global tcl_platform
    switch -exact -- $tcl_platform(platform) {
      macintosh {
        set Meta Command
      } 
      windows {
        set Meta Alt
      } 
      unix {
        set Meta Meta
      } 
    } 
    Pref_Add [subst {-group Bindings
      -type ENUM
      -typearg {Alt Meta Command}
      -var gred(Meta)
      -default $Meta
      -comment "Dfinition de la touche Meta"
    }]
    Pref_Add {-group Bindings
      -type ENUM
      -typearg {Shift Control Meta Alt}
      -var gred(shift)
      -default Shift
      -comment "Dfinition de la touche Shift"
    }
    Pref_Add {-group Bindings
      -type ENUM
      -typearg {pages units}
      -var gred(arrowScroll)
      -default units
      -comment "Mode de dplacement  l'aide des flches"
      -help "Si vous choisissez \"pages\" le dplacement  l'aide des flches se fera pages par pages.\nSinon il se fera par petits dplacements successifs."
    }
}
