# Proposition de Package d'analyse d'argument :


package provide parsarg 0.1



########################################################################
# Parsarg_Spec2 -- analyse d'option en fonction de specifs simplifies
# 
# Principe : Chaque spec simplifie  est range dans le tableau sw :
#            set sw(debug) flag
#            set sw(level) 0
# 
proc Parsarg_Spec2 {arglistName arrayName specs} {

    upvar 1 $arrayName arga
    upvar 1 $arglistName argl
    
    # Au cas ou il n'y a rien  faire !!
    if {"x[string index $argl 0]" !=  "x-"} return
    
    # On exploite les specs simplifies dans un tableau :
    array set sw $specs
    
    # Initialisation des valeurs par dfaut :
    foreach theSwitch [array names sw] {
      switch -exact -- $sw($theSwitch) {
        flag {
           # Initialisation d'un flag (mode "flag")
           set $arga($theSwitch) 0
        }
        default {
           # Initialisation d'une valeur (mode "normal")
           set $arga($theSwitch) $sw($theSwitch)
        }
      }
    }
    
    # Examen de la liste d'argument (i.e. -level):
    set argc [llength $argl]
    for {set i 0} {$i < $argc} {incr i} {
    
      # lecture de l'argument  examiner
      set arg [lindex $argl $i]
      
      # examen de tous les cas possibles pour cet argument
      switch -glob -- $arg {
         --       {break}
         -*       {
         
            # on viret le "-" de "-level"...
            set opt [string range $arg 1 end]
            # sw($opt) contient la spec simplifie (flag ou <defautVal>)
            
            if ![info exists sw($opt)] {
               
               # switch inexistant : 
               error "Unknow option $opt.\n\
                     [Parsarg_GetAllowedOptions2 specs]"
               
            } else {
                 
               # TOUT VA BIEN : Le switch exist
               switch -exact -- $sw($opt) {
               
                 flag {
                   # traitement d'un switch :
                   set $arga($opt) 1
                 }
                 
                 default {
                   # mode "normal"  une valeur :
                   set $arga($opt) [lindex argl [incr i]]
                 }
               }
            }
         }
         default  {incr i -1; break  ;# no more options}
      }
    }
    # i pointe sur le dernier lment exploit.
    set argl [lrange $argl [incr i]  end]
    
    # si argl reprsente "argv", il faudrait metter  jour argc
    # mais comment le savoir ??
  
    
}
########################################################################
########################################################################
########################################################################

########################################################################
# Parsarg_Spec2 -- extraction d'options en fonction d'une specif complte
# 
# Parametres :   ?-partial? arglistName arrayName specs
# 
#  arglistName : nom de la liste  analyser
#  arrayName : nom du tableau des valeurs  positionner
#  specs : description "complte" des options
#  -partial : tolre les options inconnues et conserve "--"
#             Dans ce cas, les options acceptes doivent tre 
#             en premier
# 
# Principe : Chaque spec est d'abord convertie en spec standard
#            (i.e. non abrge) puis range sous forme de tableau.
#               set swa-level(-mode) normal
#               set swa-level(-default) "0"
#               set swa-debug(-mode) flag
proc Parsarg_Spec2 {args} {

    # 1 - Extraction des arguments
    # 
    global report
    set report(verboseLevel) 1
    set PARTIAL 0
    set i  0
    set argc [llength $args]
    #  on n'examine les options que s'il y en a :  :
    if {"x[string index $args 0]" == "x-"} {
      while {$i < $argc} {
        set arg [lindex $args $i]
        switch -glob -- $arg {
           --       {incr i ; break}
           -p       -
           -partial { set PARTIAL 1}
           -d       -
           -debug   {set report(verboseLevel) 2}
           -*       {error "unknow option $arg"}
           default  {break  ;# no more options}
        }
        incr i
      }
    }
    
    # i pointe sur le prochain argument non lu :
    set args [lrange $args $i end]
    if {[llength $args] != 3} {
      error "syntaxe: Parsarg_Spec2 ?-partial? arglistName arrayName specs"
    }
    # Affectation des trois arguments
    foreach {arglistName arrayName specs} $args {}
    
    report -2 -v PARTIAL report(verboseLevel) \
                 arglistName arrayName specs

    upvar 1 $arrayName arga
    upvar 1 $arglistName argl
    
    # Au cas ou il n'y a rien  faire !!
    if {"x[string index $argl 0]" != "x-"} return
    
    report -2 "Liste  analyser :"
    report -2 -v argl
    # 1 - Prtraitement des specs avant analyse de la liste argl
    #     L'exploration se fait en commancant par la fin pour
    #     faciliter l'interprtation des switch alias "-"
    # On cre des tableaux de la forme :
    #  set swabackground(-default) white ; set swabackground(-variable) ...
    #  set swabg(-alias) background
    # Ce tableau sera accessible sous le nom "sw" pour chaque switch.
    
    set aliasToSwitch "unknownSwitch"
    set i  [llength $specs]
    if {$i & 1} {error "specs doit tre une liste paire"}
    
    while {$i >= 2} {
       
       set theSpec     [lindex $specs [incr i -1]]
       set theSwitch   "-[lindex $specs [incr i -1]]"
       
       # Le tableau "swabackground" sera accessible sous le nom "sw"
       upvar 0 swa$theSwitch sw

       # 3 - Affectation des valeurs de cl par dfaut (qui seront ignore
       #     dans le mode alias)
       array set sw "
         -variable arga($theSwitch)
         -mode     normal
         -type     string
       "
       if {[llength $theSpec] == 1} {

         # 4 - On remplace les specs simplifies ("-", "flag", ...)
         #     par des specs standards equivalentes :
         #     "flag"  => {-mode flag}
         #     "-"     => {-alias <otherSwitch>}
         #     XXX     => {-default XXX}
         
         switch -exact -- $theSpec {
           "-"     {
              set sw(-alias) $aliasToSwitch
              # plus besoin d'aller plus loin : aliasToSwitch est deja traiter
              continue
           }
           "flag"  {
              set theSpec {-mode flag  -default 0  -value 1}
           }
           default {
              set theSpec [list  -default [lindex $theSpec 0]]
           }
         }
       }
              
        # 5 - La spec "standard" est convertie en tableau
       array set sw $theSpec
       
       # 6 - affectation eventuelle des valeurs par dfaut de l'option
       #     (AVANT la lecture de la liste d'argument)
       if {[info exists sw(-default)]} {
          report -2 "Initialisation : [list set $sw(-variable) $sw(-default) ]"
          uplevel 1 [list set $sw(-variable) $sw(-default) ]
       }
       
       # On mmorise ce switch pour le prochain "-" ventuel
       set aliasToSwitch   $theSwitch
       
    }
    # La specification d'option pour chaque switch est maintenant 
    # dfinie par un tableau de nom "swa<theSwitch>".

    report -2 "######\n######\nExamen des tableau prtraits\
              :\n######\n######"
    set arrayList [lsort [info local swa*]]
    report -2 "arrayList contient [llength $arrayList] tableaux : $arrayList"
    foreach ar $arrayList { report -2 -v  $ar}

    

    ####################################################################
    # on commence  analyser la liste d'arguments effectivement passs
    set verifProcPrefix "Parsarg_VerifType_"
    set argc [llength $argl]
    set i 0
    while {$i < $argc} {
    
      # lecture de l'argument  examiner
      set arg [lindex $argl $i]
      
      report -2 -v i arg

      # examen de tous les cas possibles pour cet argument
      #   "--" : est extrait, puis l'extraction est interrompue,
      #   "-*" : examen et traitement du switch.
      #   autre : ce n'est plus une option 
      
      switch -glob -- $arg {
      
         --  {
             # Si option -partiel  => on conserve "--"
             if {$PARTIAL} {incr i -1}
             break
         }
                    
         -*  {
          
             # acces au tableau contenant la spcif de ce switch :
             upvar 0 swa$arg sw

             # Traitement d'un switch inexistant
             if {![array exists sw]} {
                if {$PARTIAL} {
                  incr i -1
                  break
                } else {
                  # TRAITER EVENTUELLEMENT ICI LES SWITCHS COLLS
                  # AVANT DE HURLER
                  error "unknow option $arg\n\
                       [Parsarg_GetAllowedOptions $specs]"
                }
             }
             
             # Si c'est un alias : on redirige l'acces vers le bon switch :
             if {[info exists sw(-alias)]} {
                upvar 0 swa$sw(-alias) sw
             }
             
             # Tout va bien, le switch existe : AU BOULOT
             switch -exact -- $sw(-mode) {
             
               flag {
                 
                 # traitement d'un switch :
                 
                 # sw(-value) peut tre indfinie si la spcification
                 # est explicite, mais incomplte.
                 if {![info exist sw(-value)]} {  set sw(-value) 1  }
                 uplevel [list set $sw(-variable) $sw(-value)]
                 if [info exists sw(-action)] {
                    regsub -all "%v" $sw(-action) $sw(-value) sw(-action)
                    uplevel $sw(-action)
                 }
               }
               
               normal {
               
                 # mode "normal"  une valeur :
                 
                 set val [lindex argl [incr i]]
                 
                 # traitement de l'option de cl -type
                 set verifCmd "$verifProcPrefix$sw(-type)"
                 if ![string compare [info proc $verifCmd] ""] {
                    $verifCmd $val
                 }
                 
                 # traitement de l'option de cl -filter
                 # sw(-filter) peut tre form de plusieurs mots/options
                 if [info exists sw(-filter)] {
                    set val [eval sw(-filter) [list $val]]
                 }
                 
                 # traitement de l'option de cl -action
                 if [info exists sw(-action)] {
                    # DANGER si $val contient "\&" ou "\1" ...
                    regsub -all "%v" $sw(-action) $val sw(-action)
                    uplevel  $sw(-action)
                 }
                 
               }
               
               default {
               
                  error "mode $sw($mode) non implmennt\n \
                         modes autoriss : flag et normal (dfaut)"
               }
             }
                
         }
         
         default  {incr i -1; break  ;# no more options}
      }
      incr i
    }
    # i pointe sur le dernier lment exploit.
    set argl [lrange $argl [incr i]  end]
    # si argl reprsente "argv", il faudrait mettre  jour argc
    # mais comment le savoir ??
    
    
} ;# endproc Parsarg_Spec


########################################################################
# Parsarg_GetAllowedOptions - retourne options autorise (specs compltes)
# 
# Imprime la liste des options autorises avec les labels ventuels
# 
proc Parsarg_GetAllowedOptions {fullSpecs} {
    
    # Liste des switch dans l'ordre de la specif
    set switchList {}
    foreach {theSwitch thsSpec} $fullSpecs {
      lappend switchList $theSwitch
    }
    
    set msg "switch autoriss :\n$switchList\n"
    foreach theSwitch $switchList {
      upvar 1 swa$theSwitch sw
      parray sw
      append msg "$theSwitch\n"
      if [info exists sw(-alias) ] {
        append msg "    alias de  $sw(-alias)\n"
        continue
      }
      if [info exists sw(-mode) ] {
        append msg "    mode : $sw(-mode)\n"
      }
      if [info exists sw(-label) ] {
        append msg "    $sw(-label)\n"
      }
      append msg "    variable : $sw(-variable)\n"
      if [info exists sw(-default) ] {
        append msg "    default : $sw(-default)\n"
      }
      if [info exists sw(-type) ] {
        append msg "    type : $sw(-type)\n"
      }
      if [info exists sw(-action) ] {
        append msg "    action : $sw(-action)\n"
      }
      if [info exists sw(-filter) ] {
        append msg "    filtre : $sw(-filter)\n"
      }
    }
    return $msg

}
########################################################################
# Parsarg_GetAllowedOptions2 - retourne options autorises (abrge)
# 
# Imprime la liste des options autorises pour une spec simplifie
# 
proc Parsarg_GetAllowedOptions2 {SimpleSpecs} {
        
    set msg "switch autoriss :\n"
    foreach {theSwitch theSpec} $SimpleSpecs {
      append msg -$theSwitch :
      switch -exact -- $theSpec {
        flag {append msg mode "flag" boolean}
        default {append msg mode "normal" default = $theSpec}
      }
    }
    return $msg

}


########################################################################
# Procdures de vrification de type :

proc Parsarg_VerifType_integer {string} {
    lindex {1 2 3} $string
}
proc Parsarg_VerifType_string {string} {}
proc Parsarg_VerifType_boolean {string} {
    if {![regexp {^1|0|true|false|yes|no$} $string]} {
      error "$string is not a boolean"
    }
}

########################################################################
########################################################################
